﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Runtime.CompilerServices;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace IpTextBoxExample
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }
        List<Person> list = null;
        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            list = new List<Person>();
            for (int i = 1; i < 11; i++)
            {
                list.Add(new Person()
                {
                    Name = "P " + i,
                    AddressInVM = "123.123.123.123"
                });
            }

            datagrid.ItemsSource = list;
        }

        private void IPTextBox_MouseDoubleClick(object sender, MouseButtonEventArgs e)
        {
            datagrid.BeginEdit();
        }
    }

    public class Person : INotifyPropertyChanged
    {
        private string _name = "";
        private string _Ip = "0.0.0.0";
        public string Name
        {
            get
            {
                return _name;
            }
            set
            {
                if (_name != value)
                {
                    _name = value;
                    NotifyPropertyChanged();
                }
            }
        }
        public string AddressInVM {
            get {
                return _Ip;
            }
            set
            {
                if (_Ip!= value)
                {
                    if (value =="...")
                    {
                        _Ip = "0.0.0.0";
                    }
                    else if (value == ".0.0.0")
                    {
                        _Ip = "0.0.0.0";
                    }
                    else if (value == "0.0.0.")
                    {
                        _Ip = "0.0.0.0";
                    }
                    else if (value == "0.0..0")
                    {
                        _Ip = "0.0.0.0";
                    }
                    else if (value == "0..0.0")
                    {
                        _Ip = "0.0.0.0";
                    }
                    else
                    {
                        _Ip = value;
                    }
                    NotifyPropertyChanged();
                }
            }
        } 

        public event PropertyChangedEventHandler PropertyChanged;


        // This method is called by the Set accessor of each property.
        // The CallerMemberName attribute that is applied to the optional propertyName
        // parameter causes the property name of the caller to be substituted as an argument.
        private void NotifyPropertyChanged([CallerMemberName] String propertyName = "")
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }
    }
}
